package processing

import (
	"cloud.o-forge.io/core/oc-lib/dbs/mongo"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type ProcessingMongoAccessor struct {
	utils.AbstractAccessor
}

func (pma *ProcessingMongoAccessor) DeleteOne(id string) (utils.DBObject, int, error) {
	return pma.GenericDeleteOne(id, pma)
}

func (pma *ProcessingMongoAccessor) UpdateOne(set map[string]interface{}, id string) (utils.DBObject, int, error) {
	return pma.GenericUpdateOne(set, id, pma)
}

func (pma *ProcessingMongoAccessor) StoreOne(data utils.DBObject) (utils.DBObject, int, error) {
	return pma.GenericStoreOne(data, pma)
}

func (pma *ProcessingMongoAccessor) CopyOne(data utils.DBObject) (utils.DBObject, int, error) {
	return pma.GenericStoreOne(data, pma)
}

func (pma *ProcessingMongoAccessor) LoadOne(id string) (utils.DBObject, int, error) {

	var processing ProcessingResource

	res_mongo, code, err := mongo.MONGOService.LoadOne(id, pma.GetType())
	if err != nil {
		pma.Logger.Error().Msg("Could not retrieve " + id + " from db. Error: " + err.Error())
		return nil, code, err
	}

	res_mongo.Decode(&processing)

	return &processing, 200, nil
}
