package storage

import (
	"cloud.o-forge.io/core/oc-lib/dbs/mongo"
	"cloud.o-forge.io/core/oc-lib/models/utils"
)

type StorageMongoAccessor struct {
	utils.AbstractAccessor
}

func (sma *StorageMongoAccessor) DeleteOne(id string) (utils.DBObject, int, error) {
	return sma.GenericDeleteOne(id, sma)
}

func (sma *StorageMongoAccessor) UpdateOne(set map[string]interface{}, id string) (utils.DBObject, int, error) {
	return sma.GenericUpdateOne(set, id, sma)
}

func (sma *StorageMongoAccessor) StoreOne(data utils.DBObject) (utils.DBObject, int, error) {
	return sma.GenericStoreOne(data, sma)
}

func (sma *StorageMongoAccessor) CopyOne(data utils.DBObject) (utils.DBObject, int, error) {
	return sma.GenericStoreOne(data, sma)
}

func (sma *StorageMongoAccessor) LoadOne(id string) (utils.DBObject, int, error) {

	var storage StorageResource

	res_mongo, code, err := mongo.MONGOService.LoadOne(id, sma.GetType())
	if err != nil {
		sma.Logger.Error().Msg("Could not retrieve " + id + " from db. Error: " + err.Error())
		return nil, code, err
	}

	res_mongo.Decode(&storage)

	return &storage, 200, nil
}
